| Flutter Impeller |

Public Types | Public Member Functions | Static Public Member Functions | List of all members
impeller::FilterContents Class Referenceabstract

`#include <filter_contents.h>`

Inheritance diagram for impeller::FilterContents:

## Public Types
enum | BlurStyle { BlurStyle::kNormal, BlurStyle::kSolid, BlurStyle::kOuter, BlurStyle::kInner }
enum | MorphType { MorphType::kDilate, MorphType::kErode }
Public Types inherited from impeller::Contents
using | ColorFilterProc = std::function< Color(Color)>
using | RenderProc = std::function< bool(const ContentContext &renderer, const Entity &entity, RenderPass &pass)>
using | CoverageProc = std::function< std::optional< Rect >(const Entity &entity)>

## Public Member Functions
| FilterContents ()
| ~FilterContents () override
void | SetInputs (FilterInput::Vector inputs)
| The input texture sources for this filter. Each input's emitted texture is expected to have premultiplied alpha colors. More...
void | SetEffectTransform (const Matrix &effect_transform)
| Sets the transform which gets appended to the effect of this filter. Note that this is in addition to the entity's transform. More...
std::optional< Entity > | GetEntity (const ContentContext &renderer, const Entity &entity, const std::optional< Rect > &coverage_hint) const
| Create an Entity that renders this filter's output. More...
bool | Render (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
std::optional< Rect > | GetCoverage (const Entity &entity) const override
| Get the area of the render pass that will be affected when this contents is rendered. More...
void | PopulateGlyphAtlas (const std::shared_ptr< LazyGlyphAtlas > &lazy_glyph_atlas, Scalar scale) override
| Add any text data to the specified lazy atlas. The scale parameter must be used again later when drawing the text. More...
std::optional< Snapshot > | RenderToSnapshot (const ContentContext &renderer, const Entity &entity, std::optional< Rect > coverage_limit=std::nullopt, const std::optional< SamplerDescriptor > &sampler_descriptor=std::nullopt, bool msaa_enabled=true, const std::string &label="Filter Snapshot") const override
| Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`. More...
const FilterContents * | AsFilter () const override
| Cast to a filter. Returns `nullptr` if this Contents is not a filter. More...
std::optional< Rect > | GetSourceCoverage (const Matrix &effect_transform, const Rect &output_limit) const
| Determines the coverage of source pixels that will be needed to produce results for the specified |output_limit| under the specified |effect_transform|. This is essentially a reverse of the |GetCoverage| method computing a source coverage from an intended |output_limit| coverage. More...
virtual Matrix | GetLocalTransform (const Matrix &parent_transform) const
Matrix | GetTransform (const Matrix &parent_transform) const
virtual bool | IsTranslationOnly () const
| Returns true if this filter graph doesn't perform any basis transforms to the filtered content. For example: Rotating, scaling, and skewing are all basis transforms, but translating is not. More...
bool | IsLeaf () const
| Returns `true` if this filter does not have any `FilterInput` children. More...
void | SetLeafInputs (const FilterInput::Vector &inputs)
| Replaces the set of all leaf `FilterContents` with a new set of `FilterInput`s. More...
virtual void | SetRenderingMode (Entity::RenderingMode rendering_mode)
| Marks this filter chain as applying in a subpass scenario. More...
Public Member Functions inherited from impeller::Contents
| Contents ()
virtual | ~Contents ()
void | SetCoverageHint (std::optional< Rect > coverage_hint)
| Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`. More...
const std::optional< Rect > & | GetCoverageHint () const
virtual bool | IsOpaque () const
| Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity. More...
virtual ClipCoverage | GetClipCoverage (const Entity &entity, const std::optional< Rect > &current_clip_coverage) const
| Given the current pass space bounding rectangle of the clip buffer, return the expected clip coverage after this draw call. This should only be implemented for contents that may write to the clip buffer. More...
virtual bool | ShouldRender (const Entity &entity, const std::optional< Rect > clip_coverage) const
std::optional< Size > | GetColorSourceSize () const
| Return the color source's intrinsic size, if available. More...
void | SetColorSourceSize (Size size)
virtual bool | CanInheritOpacity (const Entity &entity) const
| Whether or not this contents can accept the opacity peephole optimization. More...
virtual void | SetInheritedOpacity (Scalar opacity)
| Inherit the provided opacity. More...
virtual std::optional< Color > | AsBackgroundColor (const Entity &entity, ISize target_size) const
| Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation. More...
virtual bool | ApplyColorFilter (const ColorFilterProc &color_filter_proc)
| If possible, applies a color filter to this contents inputs on the CPU. More...

## Static Public Member Functions
static std::shared_ptr< FilterContents > | MakeDirectionalGaussianBlur (FilterInput::Ref input, Sigma sigma, Vector2 direction, BlurStyle blur_style=BlurStyle::kNormal, Entity::TileMode tile_mode=Entity::TileMode::kDecal, bool is_second_pass=false, Sigma secondary_sigma={})
static std::shared_ptr< FilterContents > | MakeGaussianBlur (const FilterInput::Ref &input, Sigma sigma_x, Sigma sigma_y, BlurStyle blur_style=BlurStyle::kNormal, Entity::TileMode tile_mode=Entity::TileMode::kDecal)
static std::shared_ptr< FilterContents > | MakeBorderMaskBlur (FilterInput::Ref input, Sigma sigma_x, Sigma sigma_y, BlurStyle blur_style=BlurStyle::kNormal)
static std::shared_ptr< FilterContents > | MakeDirectionalMorphology (FilterInput::Ref input, Radius radius, Vector2 direction, MorphType morph_type)
static std::shared_ptr< FilterContents > | MakeMorphology (FilterInput::Ref input, Radius radius_x, Radius radius_y, MorphType morph_type)
static std::shared_ptr< FilterContents > | MakeMatrixFilter (FilterInput::Ref input, const Matrix &matrix, const SamplerDescriptor &desc)
static std::shared_ptr< FilterContents > | MakeLocalMatrixFilter (FilterInput::Ref input, const Matrix &matrix)
static std::shared_ptr< FilterContents > | MakeYUVToRGBFilter (std::shared_ptr< Texture > y_texture, std::shared_ptr< Texture > uv_texture, YUVColorSpace yuv_color_space)
Static Public Member Functions inherited from impeller::Contents
static std::shared_ptr< Contents > | MakeAnonymous (RenderProc render_proc, CoverageProc coverage_proc)

## Detailed Description

Definition at line 21 of file filter_contents.h.

## Member Enumeration Documentation

## ◆ BlurStyle

enum impeller::FilterContents::BlurStyle
| strong

Enumerator
kNormal | Blurred inside and outside.
kSolid | Solid inside, blurred outside.
kOuter | Nothing inside, blurred outside.
kInner | Blurred inside, nothing outside.

Definition at line 23 of file filter_contents.h.

23 {
24 /// Blurred inside and outside.
25 kNormal,
26 /// Solid inside, blurred outside.
27 kSolid,
28 /// Nothing inside, blurred outside.
29 kOuter,
30 /// Blurred inside, nothing outside.
31 kInner,
32 };

## ◆ MorphType

enum impeller::FilterContents::MorphType
| strong

Enumerator
kDilate |
kErode |

Definition at line 34 of file filter_contents.h.

34 { kDilate, kErode };

## Constructor & Destructor Documentation

## ◆ FilterContents()

impeller::FilterContents::FilterContents | ( |  | ) |
| default

## ◆ ~FilterContents()

impeller::FilterContents::~FilterContents | ( |  | ) |
| override default

## Member Function Documentation

## ◆ AsFilter()

const FilterContents * impeller::FilterContents::AsFilter | ( |  | ) | const
| override virtual

Cast to a filter. Returns `nullptr` if this Contents is not a filter.

Reimplemented from impeller::Contents.

Definition at line 309 of file filter_contents.cc.

309 {
310 return this;
311 }

## ◆ GetCoverage()

std::optional< Rect > impeller::FilterContents::GetCoverage | ( | const Entity & | entity | ) | const
| override virtual

Get the area of the render pass that will be affected when this contents is rendered.

During rendering, coverage coordinates count pixels from the top left corner of the framebuffer.

Returns
  The coverage rectangle. An `std::nullopt` result means that rendering this contents has no effect on the output color.

Implements impeller::Contents.

Definition at line 205 of file filter_contents.cc.

205 {
206 Entity entity_with_local_transform = entity.Clone();
207 entity_with_local_transform.SetTransform(GetTransform(entity.GetTransform()));
208
209 return GetLocalCoverage(entity_with_local_transform);
210 }

References impeller::Entity::Clone(), impeller::Entity::GetTransform(), GetTransform(), and impeller::Entity::SetTransform().

Referenced by Render().

## ◆ GetEntity()

std::optional< Entity > impeller::FilterContents::GetEntity | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | const std::optional< Rect > & | coverage_hint
| ) |  | const

Create an Entity that renders this filter's output.

Definition at line 269 of file filter_contents.cc.

272 {
273 Entity entity_with_local_transform = entity.Clone();
274 entity_with_local_transform.SetTransform(GetTransform(entity.GetTransform()));
275
276 auto coverage = GetLocalCoverage(entity_with_local_transform);
277 if (!coverage.has_value() || coverage->IsEmpty()) {
278 return std::nullopt;
279 }
280
281 return RenderFilter(inputs_, renderer, entity_with_local_transform,
282 effect_transform_, coverage.value(), coverage_hint);
283 }

References impeller::Entity::Clone(), impeller::Entity::GetTransform(), GetTransform(), and impeller::Entity::SetTransform().

Referenced by Render(), and RenderToSnapshot().

## ◆ GetLocalTransform()

Matrix impeller::FilterContents::GetLocalTransform | ( | const Matrix & | parent_transform | ) | const
| virtual

Reimplemented in impeller::LocalMatrixFilterContents.

Definition at line 313 of file filter_contents.cc.

313 {
314 return Matrix();
315 }

Referenced by GetTransform().

## ◆ GetSourceCoverage()

std::optional< Rect > impeller::FilterContents::GetSourceCoverage | ( | const Matrix & | effect_transform,
|  | const Rect & | output_limit
| ) |  | const

Determines the coverage of source pixels that will be needed to produce results for the specified |output_limit| under the specified |effect_transform|. This is essentially a reverse of the |GetCoverage| method computing a source coverage from an intended |output_limit| coverage.

Both the |output_limit| and the return value are in the transformed coordinate space, and so do not need to be transformed or inverse transformed by the |effect_transform| but individual parameters on the filter might be in the untransformed space and should be transformed by the |effect_transform| before applying them to the coverages.

The method computes a result such that if the filter is applied to a set of pixels filling the computed source coverage, it should produce an output that covers the entire specified |output_limit|.

This is useful for subpass rendering scenarios where a filter will be applied to the output of the subpass and we need to determine how large of a render target to allocate in order to collect all pixels that might affect the supplied output coverage limit. While we might end up clipping the rendering of the subpass to its destination, we want to avoid clipping out any pixels that contribute to the output limit via the filtering operation.

Returns
  The coverage bounds in the transformed space of any source pixel that may be needed to produce output for the indicated filter that covers the indicated |output_limit|.

Definition at line 247 of file filter_contents.cc.

249 {
250 auto filter_input_coverage =
251 GetFilterSourceCoverage(effect_transform_, output_limit);
252
253 if (!filter_input_coverage.has_value()) {
254 return std::nullopt;
255 }
256
257 std::optional<Rect> inputs_coverage;
258 for (const auto& input : inputs_) {
259 auto input_coverage = input->GetSourceCoverage(
260 effect_transform, filter_input_coverage.value());
261 if (!input_coverage.has_value()) {
262 return std::nullopt;
263 }
264 inputs_coverage = Rect::Union(inputs_coverage, input_coverage.value());
265 }
266 return inputs_coverage;
267 }

References impeller::TRect< Scalar >::Union().

## ◆ GetTransform()

Matrix impeller::FilterContents::GetTransform | ( | const Matrix & | parent_transform | ) | const

Definition at line 317 of file filter_contents.cc.

317 {
318 return parent_transform * GetLocalTransform(parent_transform);
319 }

References GetLocalTransform().

Referenced by GetCoverage(), and GetEntity().

## ◆ IsLeaf()

bool impeller::FilterContents::IsLeaf | ( |  | ) | const

Returns `true` if this filter does not have any `FilterInput` children.

Definition at line 329 of file filter_contents.cc.

329 {
330 for (auto& input : inputs_) {
331 if (!input->IsLeaf()) {
332 return false;
333 }
334 }
335 return true;
336 }

Referenced by SetLeafInputs().

## ◆ IsTranslationOnly()

bool impeller::FilterContents::IsTranslationOnly | ( |  | ) | const
| virtual

Returns true if this filter graph doesn't perform any basis transforms to the filtered content. For example: Rotating, scaling, and skewing are all basis transforms, but translating is not.

This is useful for determining whether a filtered object's space is compatible enough with the parent pass space to perform certain subpass clipping optimizations.

Reimplemented in impeller::MatrixFilterContents.

Definition at line 320 of file filter_contents.cc.

320 {
321 for (auto& input : inputs_) {
322 if (!input->IsTranslationOnly()) {
323 return false;
324 }
325 }
326 return true;
327 }

Referenced by impeller::MatrixFilterContents::IsTranslationOnly().

## ◆ MakeBorderMaskBlur()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeBorderMaskBlur | ( | FilterInput::Ref | input,
|  | Sigma | sigma_x,
|  | Sigma | sigma_y,
|  | BlurStyle | blur_style = `BlurStyle::kNormal`
| ) |  |
| static

Definition at line 93 of file filter_contents.cc.

97 {
98 auto filter = std::make_shared<BorderMaskBlurFilterContents>();
99 filter->SetInputs({std::move(input)});
100 filter->SetSigma(sigma_x, sigma_y);
101 filter->SetBlurStyle(blur_style);
102 return filter;
103 }

Referenced by impeller::Paint::MaskBlurDescriptor::CreateMaskBlur(), and impeller::testing::TEST_P().

## ◆ MakeDirectionalGaussianBlur()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeDirectionalGaussianBlur | ( | FilterInput::Ref | input,
|  | Sigma | sigma,
|  | Vector2 | direction,
|  | BlurStyle | blur_style = `BlurStyle::kNormal`,
|  | Entity::TileMode | tile_mode = `Entity::TileMode::kDecal`,
|  | bool | is_second_pass = `false`,
|  | Sigma | secondary_sigma = `{}`
| ) |  |
| static

Creates a gaussian blur that operates in one direction. See also: `MakeGaussianBlur`

Definition at line 34 of file filter_contents.cc.

41 {
42 auto blur = std::make_shared<DirectionalGaussianBlurFilterContents>();
43 blur->SetInputs({std::move(input)});
44 blur->SetSigma(sigma);
45 blur->SetDirection(direction);
46 blur->SetBlurStyle(blur_style);
47 blur->SetTileMode(tile_mode);
48 blur->SetIsSecondPass(is_second_pass);
49 blur->SetSecondarySigma(secondary_sigma);
50 return blur;
51 }

Referenced by MakeGaussianBlur(), and impeller::testing::TEST_P().

## ◆ MakeDirectionalMorphology()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeDirectionalMorphology | ( | FilterInput::Ref | input,
|  | Radius | radius,
|  | Vector2 | direction,
|  | MorphType | morph_type
| ) |  |
| static

Definition at line 105 of file filter_contents.cc.

109 {
110 auto filter = std::make_shared<DirectionalMorphologyFilterContents>();
111 filter->SetInputs({std::move(input)});
112 filter->SetRadius(radius);
113 filter->SetDirection(direction);
114 filter->SetMorphType(morph_type);
115 return filter;
116 }

Referenced by MakeMorphology().

## ◆ MakeGaussianBlur()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeGaussianBlur | ( | const FilterInput::Ref & | input,
|  | Sigma | sigma_x,
|  | Sigma | sigma_y,
|  | BlurStyle | blur_style = `BlurStyle::kNormal`,
|  | Entity::TileMode | tile_mode = `Entity::TileMode::kDecal`
| ) |  |
| static

Creates a gaussian blur that operates in 2 dimensions. See also: `MakeDirectionalGaussianBlur`

Definition at line 53 of file filter_contents.cc.

58 {
59 constexpr bool use_new_filter =
60 #ifdef IMPELLER_ENABLE_NEW_GAUSSIAN_FILTER
61 true;
62 #else
63 false;
64 #endif
65
66 // TODO(https://github.com/flutter/flutter/issues/131580): Remove once the new
67 // blur handles all cases.
68 if (use_new_filter) {
69 auto blur = std::make_shared<GaussianBlurFilterContents>(
70 sigma_x.sigma, sigma_y.sigma, tile_mode);
71 blur->SetInputs({input});
72 return blur;
73 }
74 std::shared_ptr<FilterContents> x_blur = MakeDirectionalGaussianBlur(
75 /*input=*/input,
76 /*sigma=*/sigma_x,
77 /*direction=*/Point(1, 0),
78 /*blur_style=*/BlurStyle::kNormal,
79 /*tile_mode=*/tile_mode,
80 /*is_second_pass=*/false,
81 /*secondary_sigma=*/{});
82 std::shared_ptr<FilterContents> y_blur = MakeDirectionalGaussianBlur(
83 /*input=*/FilterInput::Make(x_blur),
84 /*sigma=*/sigma_y,
85 /*direction=*/Point(0, 1),
86 /*blur_style=*/blur_style,
87 /*tile_mode=*/tile_mode,
88 /*is_second_pass=*/true,
89 /*secondary_sigma=*/sigma_x);
90 return y_blur;
91 }

References kNormal, impeller::FilterInput::Make(), MakeDirectionalGaussianBlur(), and impeller::Sigma::sigma.

Referenced by impeller::Paint::MaskBlurDescriptor::CreateMaskBlur(), impeller::testing::TEST_P(), and impeller::BlurImageFilter::WrapInput().

## ◆ MakeLocalMatrixFilter()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeLocalMatrixFilter | ( | FilterInput::Ref | input,
|  | const Matrix & | matrix
| ) |  |
| static

Definition at line 141 of file filter_contents.cc.

143 {
144 auto filter = std::make_shared<LocalMatrixFilterContents>();
145 filter->SetInputs({std::move(input)});
146 filter->SetMatrix(matrix);
147 return filter;
148 }

Referenced by impeller::LocalMatrixImageFilter::WrapInput().

## ◆ MakeMatrixFilter()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeMatrixFilter | ( | FilterInput::Ref | input,
|  | const Matrix & | matrix,
|  | const SamplerDescriptor & | desc
| ) |  |
| static

Definition at line 130 of file filter_contents.cc.

133 {
134 auto filter = std::make_shared<MatrixFilterContents>();
135 filter->SetInputs({std::move(input)});
136 filter->SetMatrix(matrix);
137 filter->SetSamplerDescriptor(desc);
138 return filter;
139 }

Referenced by impeller::testing::TEST(), and impeller::MatrixImageFilter::WrapInput().

## ◆ MakeMorphology()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeMorphology | ( | FilterInput::Ref | input,
|  | Radius | radius_x,
|  | Radius | radius_y,
|  | MorphType | morph_type
| ) |  |
| static

Definition at line 118 of file filter_contents.cc.

122 {
123 auto x_morphology = MakeDirectionalMorphology(std::move(input), radius_x,
124 Point(1, 0), morph_type);
125 auto y_morphology = MakeDirectionalMorphology(
126 FilterInput::Make(x_morphology), radius_y, Point(0, 1), morph_type);
127 return y_morphology;
128 }

References impeller::FilterInput::Make(), and MakeDirectionalMorphology().

Referenced by impeller::testing::TEST_P(), impeller::DilateImageFilter::WrapInput(), and impeller::ErodeImageFilter::WrapInput().

## ◆ MakeYUVToRGBFilter()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeYUVToRGBFilter | ( | std::shared_ptr< Texture > | y_texture,
|  | std::shared_ptr< Texture > | uv_texture,
|  | YUVColorSpace | yuv_color_space
| ) |  |
| static

Definition at line 150 of file filter_contents.cc.

153 {
154 auto filter = std::make_shared<impeller::YUVToRGBFilterContents>();
155 filter->SetInputs({impeller::FilterInput::Make(y_texture),
156 impeller::FilterInput::Make(uv_texture)});
157 filter->SetYUVColorSpace(yuv_color_space);
158 return filter;
159 }

References impeller::FilterInput::Make().

Referenced by impeller::DlImageImpeller::MakeFromYUVTextures(), and impeller::testing::TEST_P().

## ◆ PopulateGlyphAtlas()

void impeller::FilterContents::PopulateGlyphAtlas | ( | const std::shared_ptr< LazyGlyphAtlas > & | lazy_glyph_atlas,
|  | Scalar | scale
| ) |  |
| override virtual

Add any text data to the specified lazy atlas. The scale parameter must be used again later when drawing the text.

Reimplemented from impeller::Contents.

Definition at line 212 of file filter_contents.cc.

214 {
215 for (auto& input : inputs_) {
216 input->PopulateGlyphAtlas(lazy_glyph_atlas, scale);
217 }
218 }

## ◆ Render()

bool impeller::FilterContents::Render | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| override virtual

Implements impeller::Contents.

Definition at line 177 of file filter_contents.cc.

179 {
180 auto filter_coverage = GetCoverage(entity);
181 if (!filter_coverage.has_value()) {
182 return true;
183 }
184
185 // Run the filter.
186
187 auto maybe_entity = GetEntity(renderer, entity, GetCoverageHint());
188 if (!maybe_entity.has_value()) {
189 return true;
190 }
191 return maybe_entity->Render(renderer, pass);
192 }

References GetCoverage(), impeller::Contents::GetCoverageHint(), and GetEntity().

## ◆ RenderToSnapshot()

std::optional< Snapshot > impeller::FilterContents::RenderToSnapshot | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | std::optional< Rect > | coverage_limit = `std::nullopt`,
|  | const std::optional< SamplerDescriptor > & | sampler_descriptor = `std::nullopt`,
|  | bool | msaa_enabled = `true`,
|  | const std::string & | label = `"Filter Snapshot"`
| ) |  | const
| override virtual

Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`.

Reimplemented from impeller::Contents.

Definition at line 285 of file filter_contents.cc.

291 {
292 // Resolve the render instruction (entity) from the filter and render it to a
293 // snapshot.
294 if (std::optional<Entity> result =
295 GetEntity(renderer, entity, coverage_limit);
296 result.has_value()) {
297 return result->GetContents()->RenderToSnapshot(
298 renderer, // renderer
299 result.value(), // entity
300 coverage_limit, // coverage_limit
301 std::nullopt, // sampler_descriptor
302 true, // msaa_enabled
303 label); // label
304 }
305
306 return std::nullopt;
307 }

References GetEntity().

## ◆ SetEffectTransform()

void impeller::FilterContents::SetEffectTransform | ( | const Matrix & | effect_transform | ) |

Sets the transform which gets appended to the effect of this filter. Note that this is in addition to the entity's transform.

This is useful for subpass rendering scenarios where it's difficult to encode the current transform of the layer into the Entity being rendered.

Definition at line 169 of file filter_contents.cc.

169 {
170 effect_transform_ = effect_transform;
171
172 for (auto& input : inputs_) {
173 input->SetEffectTransform(effect_transform);
174 }
175 }

## ◆ SetInputs()

void impeller::FilterContents::SetInputs | ( | FilterInput::Vector | inputs | ) |

The input texture sources for this filter. Each input's emitted texture is expected to have premultiplied alpha colors.

The number of required or optional textures depends on the particular filter's implementation.

Definition at line 165 of file filter_contents.cc.

165 {
166 inputs_ = std::move(inputs);
167 }

## ◆ SetLeafInputs()

void impeller::FilterContents::SetLeafInputs | ( | const FilterInput::Vector & | inputs | ) |

Replaces the set of all leaf `FilterContents` with a new set of `FilterInput`s.

See also
  `FilterContents::IsLeaf`

Definition at line 338 of file filter_contents.cc.

338 {
339 if (IsLeaf()) {
340 inputs_ = inputs;
341 return;
342 }
343 for (auto& input : inputs_) {
344 input->SetLeafInputs(inputs);
345 }
346 }

References IsLeaf().

## ◆ SetRenderingMode()

void impeller::FilterContents::SetRenderingMode | ( | Entity::RenderingMode | rendering_mode | ) |
| virtual

Marks this filter chain as applying in a subpass scenario.

        Subpasses render in screenspace, and this setting informs filters
        that the current transform matrix of the entity is not stored
        in the Entity transform matrix. Instead, the effect transform
        is used in this case.

Reimplemented in impeller::MatrixFilterContents.

Definition at line 348 of file filter_contents.cc.

348 {
349 for (auto& input : inputs_) {
350 input->SetRenderingMode(rendering_mode);
351 }
352 }

Referenced by impeller::MatrixFilterContents::SetRenderingMode().

The documentation for this class was generated from the following files:

- impeller/entity/contents/filters/filter_contents.h
- impeller/entity/contents/filters/filter_contents.cc

impeller::FilterContents::IsLeaf
bool IsLeaf() const
Returns true if this filter does not have any FilterInput children.
Definition: filter_contents.cc:329
impeller::FilterInput::Make
static FilterInput::Ref Make(Variant input, bool msaa_enabled=true)
Definition: filter_input.cc:19
impeller::FilterContents::GetTransform
Matrix GetTransform(const Matrix &parent_transform) const
Definition: filter_contents.cc:317
impeller::FilterContents::MakeDirectionalGaussianBlur
static std::shared_ptr< FilterContents > MakeDirectionalGaussianBlur(FilterInput::Ref input, Sigma sigma, Vector2 direction, BlurStyle blur_style=BlurStyle::kNormal, Entity::TileMode tile_mode=Entity::TileMode::kDecal, bool is_second_pass=false, Sigma secondary_sigma={})
Definition: filter_contents.cc:34
impeller::FilterContents::BlurStyle::kNormal
@ kNormal
Blurred inside and outside.
impeller::Contents::GetCoverageHint
const std::optional< Rect > & GetCoverageHint() const
Definition: contents.cc:152
impeller::Point
TPoint< Scalar > Point
Definition: point.h:308
impeller::FilterContents::MakeDirectionalMorphology
static std::shared_ptr< FilterContents > MakeDirectionalMorphology(FilterInput::Ref input, Radius radius, Vector2 direction, MorphType morph_type)
Definition: filter_contents.cc:105
impeller::FilterContents::GetCoverage
std::optional< Rect > GetCoverage(const Entity &entity) const override
Get the area of the render pass that will be affected when this contents is rendered.
Definition: filter_contents.cc:205
impeller::FilterContents::GetEntity
std::optional< Entity > GetEntity(const ContentContext &renderer, const Entity &entity, const std::optional< Rect > &coverage_hint) const
Create an Entity that renders this filter's output.
Definition: filter_contents.cc:269
impeller::FilterContents::GetLocalTransform
virtual Matrix GetLocalTransform(const Matrix &parent_transform) const
Definition: filter_contents.cc:313
impeller::TRect< Scalar >::Union
constexpr TRect Union(const TRect &o) const
Definition: rect.h:302